
#define HANDLE_ERR(err) if (err != ftOK) \
	if (err == ftAbort) \
		return filterAborted; \
	else \
		return filterProcessingError;

#include "FTFilter.h"
#define BUFSIZE	1024

pascal FilterResult main(PBCallToFilter *pb) {

	FilterResult	ResCod;
	
	ENTER_FILTER;						// set up A4 register things...
	
	switch( pb->serviceRequested ) {
	
		case msgFilterData:

			return myCoolFilter( pb );	// call your filter!
			break;

		default:
			return filterMsgNotHandled;
	}

	EXIT_FILTER(ResCod);				// release A4 register things...
}

static FilterResult myCoolFilter(PBCallToFilter *pb) {

	FTErr		err, writeErr;
	Stream	inputStream;
	Stream	outputStream;
	FInfo		fndrinfo;
	FSSpec	suggested_spec;
	char		buffer[BUFSIZE];
	long		countRead;
        
	err = pb->cb->Open(input1, &inputStream, &fndrinfo, &suggested_spec);
	HANDLE_ERR(err);
	err = pb->cb->Open(output1, &outputStream, &fndrinfo, &suggested_spec);
	HANDLE_ERR(err);
        
		// loop until no data left
	while (err != ftEndOfData) {
		countRead = BUFSIZE;
		
		// call back to the filtering engine for some more stuff to filter.
		err = pb->cb->Read(inputStream, buffer, &countRead);
        
		// filter if you have 'em, in this case copy same stuff to output
		if (countRead > 0) {
			writeErr = pb->cb->Write(outputStream, buffer, countRead);
			HANDLE_ERR(writeErr);
		}
	}                       

	// Do any resource handling needed, in this case we're just copying
	// the original file specs, so its creator will recognize it after filtering
	err = pb->cb->CopyResources(inputStream, outputStream);
	HANDLE_ERR(err);
        
	// Close shop
	err = pb->cb->Close(inputStream);
	HANDLE_ERR(err);
	err = pb->cb->Close(outputStream);
	HANDLE_ERR(err);
	
	return filterOK;
}

// If your filter had done any memory initialization then it would need a
// routine to cleanup after itself.

